import { TagContentType } from '../../compiler/src/ml_parser/tags';
export { TagContentType };
export interface ParseOptions {
    /**
     * any element can self close
     *
     * defaults to false
     */
    canSelfClose?: boolean;
    /**
     * support [`htm`](https://github.com/developit/htm) component closing tags (`<//>`)
     *
     * defaults to false
     */
    allowHtmComponentClosingTags?: boolean;
    /**
     * do not lowercase tag names before querying their tag definitions
     *
     * defaults to false
     */
    isTagNameCaseSensitive?: boolean;
    /**
     * customize tag content type
     *
     * defaults to the content type defined in the HTML spec
     */
    getTagContentType?: (tagName: string, prefix: string, hasParent: boolean, attrs: Array<{
        prefix: string;
        name: string;
        value?: string;
    }>) => void | TagContentType;
}
export declare function parse(input: string, options?: ParseOptions): import("../../compiler/src/ml_parser/parser").ParseTreeResult;
