"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const html_parser_1 = require("../../compiler/src/ml_parser/html_parser");
const tags_1 = require("../../compiler/src/ml_parser/tags");
exports.TagContentType = tags_1.TagContentType;
let parser = null;
const getParser = () => {
    if (!parser) {
        parser = new html_parser_1.HtmlParser();
    }
    return parser;
};
function parse(input, options = {}) {
    const { canSelfClose = false, allowHtmComponentClosingTags = false, isTagNameCaseSensitive = false, getTagContentType, } = options;
    return getParser().parse(input, "angular-html-parser", {
        tokenizeExpansionForms: false,
        interpolationConfig: undefined,
        canSelfClose,
        allowHtmComponentClosingTags,
    }, isTagNameCaseSensitive, getTagContentType);
}
exports.parse = parse;
