"use strict";
exports.__esModule = true;
var document_1 = require("../factories/document");
var position_1 = require("../factories/position");
var document_body_1 = require("./document-body");
var document_head_1 = require("./document-head");
function transformDocument(document, context) {
    var _a = document_head_1.transformDocumentHead(document, context), createDocumentHeadWithTrailingComment = _a.createDocumentHeadWithTrailingComment, documentHeadEndMarkerPoint = _a.documentHeadEndMarkerPoint;
    var _b = document_body_1.transformDocumentBody(document, context, documentHeadEndMarkerPoint), documentBody = _b.documentBody, documentEndPoint = _b.documentEndPoint, documentTrailingComment = _b.documentTrailingComment, documentHeadTrailingComment = _b.documentHeadTrailingComment;
    var documentHead = createDocumentHeadWithTrailingComment(documentHeadTrailingComment);
    if (documentTrailingComment) {
        context.comments.push(documentTrailingComment);
    }
    return document_1.createDocument(position_1.createPosition(documentHead.position.start, documentEndPoint), documentHead, documentBody, documentTrailingComment);
}
exports.transformDocument = transformDocument;
