"use strict";
exports.__esModule = true;
var mapping_key_1 = require("../factories/mapping-key");
var mapping_value_1 = require("../factories/mapping-value");
var position_1 = require("../factories/position");
function transformAstPair(pair, context, createNode, additionalKeyRange, additionalValueRange) {
    var keyContent = context.transformNode(pair.key);
    var valueContent = context.transformNode(pair.value);
    var mappingKey = keyContent || additionalKeyRange
        ? mapping_key_1.createMappingKey(context.transformRange({
            origStart: additionalKeyRange
                ? additionalKeyRange.origStart
                : keyContent.position.start.offset,
            origEnd: keyContent
                ? keyContent.position.end.offset
                : additionalKeyRange.origStart + 1
        }), keyContent)
        : null;
    var mappingValue = valueContent || additionalValueRange
        ? mapping_value_1.createMappingValue(context.transformRange({
            origStart: additionalValueRange
                ? additionalValueRange.origStart
                : // istanbul ignore next
                    valueContent.position.start.offset,
            origEnd: valueContent
                ? valueContent.position.end.offset
                : additionalValueRange.origStart + 1
        }), valueContent)
        : null;
    return createNode(position_1.createPosition(mappingKey ? mappingKey.position.start : mappingValue.position.start, mappingValue ? mappingValue.position.end : mappingKey.position.end), mappingKey ||
        mapping_key_1.createMappingKey(position_1.createEmptyPosition(mappingValue.position.start), null), mappingValue ||
        mapping_value_1.createMappingValue(position_1.createEmptyPosition(mappingKey.position.end), null));
}
exports.transformAstPair = transformAstPair;
