"use strict";
exports.__esModule = true;
var FINISH = true;
function addOrigRange(cst) {
    if (!cst.setOrigRanges()) {
        var fn_1 = function (obj) {
            if (isRange(obj)) {
                obj.origStart = obj.start;
                obj.origEnd = obj.end;
                return FINISH;
            }
            if (isFlowChar(obj)) {
                obj.origOffset = obj.offset;
                return FINISH;
            }
        };
        cst.forEach(function (document) { return visit(document, fn_1); });
    }
}
exports.addOrigRange = addOrigRange;
function visit(obj, fn) {
    if (!obj || typeof obj !== "object") {
        return;
    }
    if (fn(obj) === FINISH) {
        return;
    }
    for (var _i = 0, _a = Object.keys(obj); _i < _a.length; _i++) {
        var key = _a[_i];
        if (key === "context" || key === "error") {
            continue;
        }
        var value = obj[key];
        if (Array.isArray(value)) {
            value.forEach(function (x) { return visit(x, fn); });
        }
        else {
            visit(value, fn);
        }
    }
}
function isRange(obj) {
    return typeof obj.start === "number";
}
function isFlowChar(obj) {
    return typeof obj.offset === "number";
}
