"use strict";
exports.__esModule = true;
var constants_1 = require("../constants");
var comment_1 = require("../factories/comment");
function extractPropComments(node, context) {
    for (var _i = 0, _a = node.props; _i < _a.length; _i++) {
        var propRange = _a[_i];
        var leadingChar = context.text[propRange.origStart];
        switch (leadingChar) {
            case constants_1.PropLeadingCharacter.Comment:
                context.comments.push(comment_1.createComment(context.transformRange(propRange), context.text.slice(propRange.origStart + 1, propRange.origEnd)));
                break;
            // istanbul ignore next
            default:
                throw new Error("Unexpected leading character " + JSON.stringify(leadingChar));
        }
    }
}
exports.extractPropComments = extractPropComments;
